import com.fasterxml.jackson.databind.JsonNode;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.node.ObjectNode;
import com.google.gson.Gson;
import com.google.gson.JsonElement;
import com.google.gson.JsonObject;
import com.google.gson.JsonParser;
import org.codehaus.jackson.JsonFactory;
import org.codehaus.jackson.JsonGenerator;

import java.io.*;

public class Main {

    public static void main(String[] args) throws IOException {

        makeFile();

        System.out.println("gson : " + gsonCheckTime());
        System.out.println("jackson : " + jacksonCheckTime());


    }

    public static void makeFile() {
        String each_str = "{\"seen_bytes_len\":4,\"dst_ip_num\":3232235624,\"timedout\":\"false\",\"duration_len\":1,\"src_ip_city\":\"-\",\"dst_ip_lon\":0,\"dti_log_source_id\":12,\"rule\":\"CbJk9e3poCCSALueu2\",\"dst_ip_country_code\":\"-\",\"source\":\"SMB\",\"dst_ip_subdivision\":\"-\",\"dst_ip\":\"192.168.0.104\",\"src_ip\":\"192.168.0.40\",\"duration\":0,\"src_ip_lon\":0,\"dst_ip_country_name\":\"-\",\"dst_ip_city\":\"-\",\"src_ip_class\":\"192.168.0.xxx\",\"src_ip_country_name\":\"-\",\"analyzers\":\"SHA1\",\"src_ip_num\":3232235560,\"filename_reg\":\"CTILAB\\\\CTILAB\\\\Sergey\\\\data\\\\UNSW NB   Source Files\\\\UNSW NB     BRO Files\\\\BRO Files          \\\\ \\\\ \\\\  http log\",\"fuid\":\"FqW44W3HRPsQ0SYG0l\",\"seen_bytes\":4096,\"missing_bytes\":0,\"overflow_bytes_len\":1,\"src_ip_subdivision\":\"-\",\"local_orig\":\"true\",\"analyzers_code\":5,\"dst_ip_lat\":0,\"is_orig\":\"false\",\"dti_log_type_id\":19,\"overflow_bytes\":0,\"sha1\":\"ee9aad940bfc6a586ac8b6524df443843bbe98e8\",\"dti_time_diff\":0,\"src_ip_country_code\":\"-\",\"depth\":0,\"filename\":\"CTILAB\\\\CTILAB\\\\Sergey\\\\data\\\\UNSW-NB15 Source-Files\\\\UNSW-NB15 - BRO Files\\\\BRO Files 22-1-2015\\\\3\\\\5\\\\._http.log\",\"logtime\":\"2019-11-07T14:11:27\",\"src_ip_lat\":0,\"source_code\":4,\"hash\":\"14:11:00-14:12:00\",\"dst_ip_class\":\"192.168.0.xxx\",\"md5\":\"ae1bb18bd894839da027f25468705ab2\"}";
        File file = new File("testString.txt");
        try {
            FileWriter fw = new FileWriter(file, true);
            for (int i = 0; i < 1000000; i++)
                fw.write(each_str + "\n");
            fw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static String gsonCheckTime() {
        long start = System.currentTimeMillis();
        JsonParser parser = new JsonParser();

        try{
            File file = new File("testString.txt");
            FileReader filereader = new FileReader(file);
            BufferedReader bufReader = new BufferedReader(filereader);
            String line = "";
            while((line = bufReader.readLine()) != null){
                JsonElement je = parser.parse(line);
                JsonObject jo = je.getAsJsonObject();
                jo.add("logtime2", jo.get("logtime"));
            }
            bufReader.close();
        }catch (FileNotFoundException e) {
            // TODO: handle exception
        }catch(IOException e){
            System.out.println(e);
        }
        long end = System.currentTimeMillis();
        return "실행 시간 : " + ((end - start) / 1000.0);
    }

    public static String jacksonCheckTime() throws IOException {
        long start = System.currentTimeMillis();
        ObjectMapper mapper = new ObjectMapper();

        try{
            File file = new File("testString.txt");
            FileReader filereader = new FileReader(file);
            BufferedReader bufReader = new BufferedReader(filereader);
            String line = "";
            while((line = bufReader.readLine()) != null){
                JsonNode jn = mapper.readTree(line);
                ((ObjectNode)jn).put("logtime2", jn.get("logtime"));
            }
            bufReader.close();
        }catch (FileNotFoundException e) {
            // TODO: handle exception
        }catch(IOException e){
            System.out.println(e);
        }
        long end = System.currentTimeMillis();
        return "실행 시간 : " + ((end - start) / 1000.0);
    }



}
